//+------------------------------------------------------------------+
//|                                              #Toggle_Example.mq4 |
//|                       Copyright 2015, Automated Trading Software |
//|                            http://automatedtradingsoftware.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Automated Trading Software"
#property link      "http://automatedtradingsoftware.co.uk"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern ENUM_BASE_CORNER corner=CORNER_RIGHT_UPPER;//Select Chart Corner

extern bool value_to_Zout_Toggle=true; // The Value to Zout_Toggle
string Zout_Button="Zout_Toggle_button";

long result=-1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   Zout_Toggle();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectDelete(Zout_Button);

   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|   ZoomIN   sparam                                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|      ZoomIN   sparam                                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|      ZoomOUT   sparam                                                            |
//+------------------------------------------------------------------+

   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam==Zout_Button) Zout_Toggle();
        {
        if(ChartGetInteger(0,CHART_SCALE,0,result))
           {
            if(result==5)
              {
               ChartSetInteger(0,CHART_SCALE,0,4);//Comment
               Print("Chart Scale = "+(string)result);
              }
            else if(result==4)
              {
               ChartSetInteger(0,CHART_SCALE,0,3);
               Print("Chart Scale = "+(string)result);
              }
            else if(result==3)
              {
               ChartSetInteger(0,CHART_SCALE,0,2);
               Print("Chart Scale = "+(string)result);
              }
            else if(result==2)
              {
               ChartSetInteger(0,CHART_SCALE,0,1);
               Print("Chart Scale = "+(string)result);
              }
            else if(result==1)
              {
               ChartSetInteger(0,CHART_SCALE,0,0);
               Print("Chart Scale = "+(string)result);
              }
           }
        }
     }

  }
//+------------------------------------------------------------------+
//|      ZoomOUT   sparam                                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|  ZoomIN Toggle                                                                |
//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+
//|  ZoomOUT Toggle                                                                |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  ZoomIN Toggle                                                                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|  ZoomIN                                                                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|  ZoomIN                                                                |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ZoomOUT Toggle                                                                 |
//+------------------------------------------------------------------+
void Zout_Toggle()
  {
   color outColor=clrGreen;
   string outArrow="Zoom OUT";

   if(value_to_Zout_Toggle==true)
     {
      outColor=clrGreen;
      outArrow="Zoom OUT";
     }

   CreateZoomOUTButton(Zout_Button,outColor,"Arial",(outArrow));
   value_to_Zout_Toggle=!value_to_Zout_Toggle;

   Comment("The value of value_to_Zout_Toggle is ",result);
  }

//+------------------------------------------------------------------+
//|  ZoomOUT                                                                |
//+------------------------------------------------------------------+
void CreateZoomOUTButton(string ZoomOUT,color outColor,string sFont="Arial",string sText="")
  {

   if(ObjectFind(ZoomOUT)<0)
     {
      ObjectCreate(0,ZoomOUT,OBJ_BUTTON,0,0,0);
     }
   ObjectSetInteger(0,ZoomOUT,OBJPROP_CORNER,corner);
   ObjectSetInteger(0,ZoomOUT,OBJPROP_XDISTANCE,100);
   ObjectSetInteger(0,ZoomOUT,OBJPROP_YDISTANCE,340);
   ObjectSetInteger(0,ZoomOUT,OBJPROP_XSIZE,75);
   ObjectSetInteger(0,ZoomOUT,OBJPROP_YSIZE,20);
   ObjectSetString(0,ZoomOUT,OBJPROP_TEXT,sText);
   ObjectSetInteger(0,ZoomOUT,OBJPROP_COLOR,outColor);
   ObjectSetInteger(0,ZoomOUT,OBJPROP_STATE,result);
  }

//+------------------------------------------------------------------+
//|   ZoomOUT                                                               |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
